;Nibbles v1.0 by Geoff Lywood
;Based on Bytes and Nibbles 86, sort of...
;Also somewhat based on a nibbles game that I created in BASIC...
;email: glywood@hotmail.com
;This game supports external levels, but does not require them.
#include "ti83plus.inc"
#include "mirage.inc"
	.org	$9d93				;Origin (set back two to account for AsmPrgm)
	.db	$BB,$6D				;Compiled AsmPrgm token
	ret					;So TIOS wont run the program
	.db	1				;Identifier as MirageOS program
	.db	%00000000,%00000000
	.db	%00010001,%00000000		;15x15 button
	.db	%00011001,%00001000
	.db	%00010101,%00000000
	.db	%00010101,%00000000
	.db	%00010011,%00000000
	.db	%00010001,%00001000
	.db	%00010001,%00001000
	.db	%00000000,%00001000
	.db	%00111111,%10001000
	.db	%00100000,%00001000
	.db	%00100000,%00001000
	.db	%00111111,%11111000
	.db	%00000000,%00000000
	.db	%00000000,%00000000
						;Program code starts here
sram =appbackupscreen
direction	=sram
grow		=sram+5			; less than 6 when growing
dotx		=sram+6
doty		=sram+7
lives		=sram+8
snakemap	=sram+11
newlevs		=sram+9
num_of_levs	=sram+10		; max number of levels
saferam5 =op6
changelevel	=saferam5
scoreinc	=saferam5+1
curlevel	=saferam5+2
#define speed		speed_lbl+1		; current speed
#define score		score_lbl+1		; current score
#define level		level_lbl+1		; current level
#define vatlevels	changeset+1		; pointer to start of level set
#define levsetname	levelset_lbl+1		; pointer to the name of the level set
#define hiscore		hiscore_lbl+1		; pointer to high score data
#define levdata		levdata_lbl+1		; pointer to actual level data
#define snakestart	mainloop+1		; pointer to location in snakemap where the snake starts (inc'd every time it moves)
#define snakeend	snakeend_lbl+1		; pointer to location in snakemap where the snake ends (inc'd when not growing)
description:
	.db	"Nibbles v1.0",0
start:
	res plotLoc,(iy+plotFlags)
	bcall(_clrlcdf)
	call setlevset
	call title
	call setspeed
	call setstartlev
menuloop:
	bcall(_getcsc)
;	bcall(_getkey)	;screenshot
	or a
	jr z,menuloop
	dec a
	call z,menudown
	dec a
	call z,menuleft
	dec a
	call z,menuright
	dec a
	call z,menuup
	sub 32h
	jp z,setupvars
	dec a
	call z,changelevelset
	dec a
	ret z
	jr menuloop
menuup:
	ld a,(speed)
	cp 5
	jr nz,speedup
	xor a
speedup:
	inc a
	jr fixspeed
menudown:
	ld a,(speed)
	dec a
	jr nz,fixspeed
	ld a,5
fixspeed:
	ld (speed),a
	call setspeed
	ret
menuright:
	ld a,(num_of_levs)
	ld c,a
	ld a,(level)
	cp c
	jr nz,levelup
	xor a
levelup:
	inc a
	jr fixlevel
menuleft:
	ld a,(level)
	dec a
	jr nz,fixlevel
	ld a,(num_of_levs)
fixlevel:
	ld (level),a
	call setstartlev
	ret
;----> Starts the game
setupvars:
	ld a,(level)
	ld (curlevel),a
	ld a,5
	ld (lives),a
	xor a
	ld (score),a
	ld (score+1),a
	ld a,(speed)
	sla a
	dec a
	ld (speed),a
	ld b,a
	ld a,10
	sub b
	ld (scoreinc),a
startover:
	bcall(_clrgbuf)
	bcall(_clrlcdf)
	call outline
	xor a
	ld (changelevel),a
	inc a
	ld (grow),a
	inc a
	ld (direction),a
	ld hl,snakemap
	ld (snakestart),hl
	ld hl,snakemap+2E6h
	ld (snakeend),hl
	ld b,24
label:				; clears the values in snakemap b/w the snake end and start
	inc hl
	ld (hl),0
	djnz label
	ld a,(curlevel)
	ld b,a
levdata_lbl:
	ld hl,0000h
	ld de,62
	dec b
	jr z,firstlevel		;if its the first level, don't add 62 at all
findlevel:
	add hl,de
	djnz findlevel
firstlevel:			;if it's the first level, jump here
	ld a,(hl)
	ld (snakemap),a
	inc hl
	ld a,(hl)
	ld (snakemap+1),a
	inc hl
	ld de,saferam3
	ld bc,60
	ldir
	ld hl,saferam3
	ld b,15
drawlevel:			;draws the level..... :)
	push bc
	ld b,(hl)
	inc hl
	ld c,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	inc hl
	push hl
	call drawline
	pop hl
	pop bc
	djnz drawlevel
	ld hl,0303h		;Displays the score, lives and level variables
	ld (currow),hl		
	ld hl,scorestr
	bcall(_puts)
	ld hl,(score)
	bcall(_disphl)
	ld hl,0304h
	ld (currow),hl
	ld hl,levelstr
	bcall(_puts)
	ld hl,(curlevel)
	ld h,0
	bcall(_disphl)
	ld hl,0305h
	ld (currow),hl
	ld hl,livesstr
	bcall(_puts)
	ld hl,(lives)
	ld h,0
	bcall(_disphl)
	call secondkey		;Pauses before the start of the game
	call iFastCopy
return:
	call delay
	ld b,29
	call iRandom
	ld d,a
	ld b,45
	call iRandom
	ld c,d
	sla a
	inc c
	inc c
	sla c
	inc a
	inc a
	inc a
	ld b,a
	ld d,2
	call setdot
	or a
	jr nz,return
	call putdot
	ld a,b
	ld (dotx),a
	ld a,c
	ld (doty),a
;----> This is the start of actual gameplay...
mainloop:
	ld hl,0000
	ld b,(hl)	; loads b with the present x coord for the start of the snake; will be changed soon...
	inc hl
	ld c,(hl)	; loads c with the y coord
	call chkifmax
	ld (snakestart),hl
	call incgrow
pauseover:
	ld a,0ffh
	out (1),a
	ld a,0feh
	out (1),a
	in a,(1)
	cp $FE
	jr z,nowdown
	cp $FB
	jr z,nowright
	cp $FD
	jr z,nowleft
	cp $F7
	jr z,nowup
	ld a,$BF
	out (1),a
	in a,(1)
	cp $7F		;Del
	jp z,dead
	cp $BF		;Mode
	jp z,pause
	ld a,(direction)
	dec a
	jr z,nowup
	dec a
	jr z,nowright
	dec a
	jr z,nowleft
nowdown:		;direction=4
	inc c
	inc c
	ld a,4
	ld (direction),a
	jr move
nowright:		;direction=2
	inc b
	inc b
	ld a,2
	ld (direction),a
	jr move
nowleft:		;direction=3
	dec b
	dec b
	ld a,3
	ld (direction),a
	jr move
nowup:			;direction=1
	dec c
	dec c
	ld a,1
	ld (direction),a
move:
	ld (hl),b
	inc hl
	ld (hl),c
	ld d,2
	call setdot	;will test pixel
	or a
	jr nz,collision
	call putdot
	call delay
	ld a,(grow)
	cp 5
	jp c,mainloop
snakeend_lbl:
	ld hl,0000h
	ld d,0
	ld b,(hl)
	inc hl
	ld c,(hl)
	call chkifmax
	ld (snakeend),hl
	call putdot2
	jp mainloop
; ----- End of actual gameplay -----
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;----> Routine to stop it from growing
incgrow:
	ld a,(grow)
	inc a
	ld (grow),a
	or a
	ret nz
	ld a,6
	ret
;----> routine to inc hl, but if it's too large, reset it to the start of snakemap
chkifmax:
	inc hl
	ld a,$6B
	cp l
	ret nc
	ld a,$9B
	cp h
	ret nz
	ld hl,snakemap
	ret
;----> Pause and turn off Routine
pause:
	ld a,1
	out (3),a
	jp pauseover
;----> Delay routine
delay:
	ld a,(speed)
	ld b,a
delayloop1:
	ei
	halt
	djnz delayloop1
;	bcall(_getkey)	;for getting screenshots
	ret
;----> Jumps here if you hit anything
collision:
	ld a,(dotx)
	cp b
	jr nz,loselife
	ld a,(doty)
	cp c
	jr nz,loselife
	ld a,(scoreinc)
	ld b,a
	ld a,(score)
	add a,b
	ld (score),a
	jr nc,lessthan256
	ld hl,score+1
	inc (hl)
lessthan256:
	ld a,1
	ld (grow),a
	ld a,(changelevel)
	inc a
	cp 10
	ld (changelevel),a
	jr z,nextlevel
	jp return
loselife:
	ld a,(lives)
	dec a
	jr z,dead
	ld (lives),a
	jp startover
;----> Jumps here if you die
dead:
	bcall(_clrlcdf)
	bcall(_clrgbuf)
	bcall(_homeup)
	ld hl,scorestr
	bcall(_puts)
score_lbl:
	ld hl,0
	bcall(_disphl)
	call newhigh
notpressed:
	bcall(_getcsc)
	cp 36h
	jr nz,notpressed
	bcall(_clrlcdf)
	call loadbuffer3
	call title
	ld a,(speed)
	inc a
	sra a
	ld (speed),a
	call setspeed
	call setstartlev
	jp menuloop
;----> takes you to the next level
nextlevel:
	xor a
	ld (changelevel),a
	ld a,(num_of_levs)
	ld b,a
	ld a,(curlevel)
	cp b
	jr z,backtostart
	inc a
	ld (curlevel),a
	jp startover
backtostart:
	ld a,1
	ld (curlevel),a
	jp startover
;----> Checks for a new high score
newhigh:
	ld hl,(hiscore)
	bcall(_ldhlind)
	ld de,(score)
	bcall(_cphlde)
	ret nc
	ld hl,(hiscore)
	ld (hl),e
	inc hl
	ld (hl),d
	ld hl,0*256+2
	ld (currow),hl
	ld hl,nhstext
	bcall(_puts)
	ret
;----> 2 by 2 dot on screen
putdot:
	ld d,1
putdot2:
	ld a,c
	or a
	ret z
	call setdot
	dec c
	call setdot
	inc b
	call setdot
	inc c
	call setdot
	dec b
	push bc
	call iFastCopy
	pop bc
	ret
;----> Routine to alter pixel with coordinates (b,c): d=1 to turn on, d=0 to turn off, d=2 to test (returns a=0 if off)
setdot:
	push bc
	push de
	ld e,c
	ld a,b
	call iGetPix	; loads a with pixel data, hl with place in gbuf
	pop de		; this tells it to turn off or on or test
	inc d
	dec d
	jr z,pixeloff2	; turns off pixel
	dec d
	jr z,pixelon	; turns on pixel
	and (hl)	; tests pixel a=1 if on, a=0 if off
	pop bc
	inc d
	or a
	ret z
	ld a,$01	; if a is not zero, make it 1
	ret
pixelon:
	or (hl)		; hl is address, a is byte with pixel data
	ld (hl),a
	pop bc
	inc d
	ret
pixeloff2:
	xor %11111111	; swaps all of the bits in a 
	and (hl)	; sets to zero all of the former 1's in a
	ld (hl),a
	pop bc
	ret
;----> Double thickness line (it tests for horiz/vert, rets if neither or b=0)
drawline:
	ld a,b
	or a
	ret z
	cp d
	jr z,vertline
	ld a,c
	cp e
	jr z,horizline
	ret
;----> Double thickness horizontal line
horizline:
	ld h,01h
	bcall(_darkline)
	dec c
	dec e
	bcall(_darkline)
	ret
;----> Double thickness vertical line
vertline:
	ld h,01h
	bcall(_darkline)
	inc b
	inc d
	bcall(_darkline)
	ret
;----> Double line outline of the screen
outline:
	push bc
	push de
	ld bc,01*256+01
	ld de,01*256+62
	call vertline
	ld bc,93*256+62
	call horizline
	inc c
	ld de,93*256+02
	call vertline
	ld bc,01*256+02
	call horizline
	pop de
	pop bc
	ret
;----> Displays title and a few words
title:
	ld bc,0*256+(63-8)
	ld de,95*256+(63-8)
	ld hl,0100
	bcall(_darkline)
	ld hl,2*256
	ld (currow),hl
	ld hl,description
	bcall(_puts)		;display title
	ld hl,9*256
	ld (pencol),hl
	ld hl,by_me
	bcall(_vputs)		;display info
	ld hl,19*256+10
	ld (pencol),hl
	ld hl,menu1
	bcall(_vputs)		;display "2nd - Start"
	ld hl,43*256+10
	ld (pencol),hl
	ld hl,menu5
	bcall(_vputs)		;display "Del - Quit"
sethigh:
	ld hl,56*256
	ld (pencol),hl
	ld hl,high
	bcall(_vputs)		;display "High:"
hiscore_lbl:
	ld hl,0
	bcall(_ldhlind)
	bcall(_setxxxxop2)
	bcall(_op2toop1)
	ld a,5
	bcall(_dispop1a)	;display high score
	call erasetoend
	ret
;----> Displays speed
setspeed:
	ld hl,menu2
	ld de,25*256+10
	ld (pencol),de
	bcall(_vputs)		;display "Up/Down - Speed"
speed_lbl:
	ld a,3
	bcall(_setxxop1)
	ld a,1
	bcall(_dispop1a)	;display speed
	ret
;----> Displays starting level
setstartlev:
	ld hl,31*256+10
	ld (pencol),hl
	ld hl,menu4
	bcall(_vputs)		;display "Left/Right - Level"
level_lbl:
	ld a,1
	bcall(_setxxop1)
	ld a,2
	bcall(_dispop1a)	;display level
	call erasetoend
	ret
;----> Changes/Displays the level set  (rather disorganized, and could have been done better...)
setlevset:
	ld hl,(progptr)
	ld ix,detectstring
	call iDetect
	jr nz,nomorelevs
loadbuffer:
	ld (vatlevels),de
	xor a
	ld (newlevs),a
loadbuffer2:
	ld a,1
	ld (level),a
	ld (levsetname),hl
	ld c,-1
	xor a
	cpir
	ld a,(hl)
	ld (num_of_levs),a
	inc hl
	ld (hiscore),hl
	inc hl
	inc hl
	ld (levdata),hl
loadbuffer3:		; calls this after you die, just displays the current level set
	ld hl,37*256+10
	ld (pencol),hl
	ld hl,menu3
	bcall(_vputs)
levelset_lbl:
	ld hl,0000h
	bcall(_vputs)
	call erasetoend
	call setstartlev
	call sethigh
	ret
nomorelevs:
	ld de,levels
	ld (vatlevels),de
	xor a
	inc a
	ld (newlevs),a		; jumps to setlevset next time
	ld hl,levels
	jr loadbuffer2
changelevelset:
	ld a,(newlevs)
	or a
	jr nz,setlevset
changeset:
	ld hl,0
	ld ix,detectstring
	call iDetect
	jr nz,nomorelevs
	jr loadbuffer
;----> Waits for the 2nd button to be pressed (or the Del key)
secondkey:
	bcall(_getcsc)
	cp 36h
	ret z
	cp 38h
	ret z
	jr secondkey
;----> Erases to the end of the line (small font)
erasetoend:
	ld a,20h
	bcall(_vputmap)
	jr nc,erasetoend
	ret
;----> Strings
by_me:
	.db "by Geoff Lywood",0
high:
	.db "High: ",0
menu1:	.db "2nd - Start",0
menu2:	.db "Up/Down - Speed: ",0
menu3:	.db "Mode: ",0
menu4:	.db "Left/Right - Level: ",0
levelstr:
	.db "Level:",0
menu5:	.db "Del - Exit",0
scorestr:
	.db "Score:",0
livesstr:
	.db "Lives:",0
nhstext:
	.db "New High Score!",0
detectstring:
	.db "Nib1GL",0
;###### Hereafter lies the standard level set ######
; These numbers were obtained from the output code 
; of the level editor, I didn't make them up...
levels:
	.db "Standard Levels",0
	.db 10
	.dw 0000h
level1:
	.db 7,8
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
level2:
	.db 7,8
	.db 44h,20h,1bh,20h,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
level3:
	.db 7,8
	.db 4ch,20h,15h,20h,31h,0dh,31h,34h,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
level4:
	.db 7,8
	.db 13h,0dh,13h,34h,48h,20h,15h,20h,49h,0dh,49h,34h
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
level5:
	.db 3,36h
	.db 1fh,13h,1fh,3ch,0fh,12h,30h,12h,50h,2eh,31h,2eh
	.db 41h,03h,41h,2ch,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
level6:
	.db 09h,38h,11h,0dh,11h,34h,4ch,0eh,11h,0eh,4bh,34h
	.db 4bh,0dh,21h,34h,4ah,34h,1fh,19h,1fh,34h,3eh,1ah
	.db 21h,1ah,3dh,26h,3dh,1bh,2dh,26h,3ch,26h,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0
level7:
	.db 31h,38h
	.db 2fh,03h,2fh,0ah,4ch,0ch,31h,0ch,13h,0ch,30h,0ch
	.db 13h,30h,13h,0bh,4bh,30h,4bh,0dh,2fh,35h,2fh,3ch
	.db 40h,34h,1fh,34h,1fh,17h,1fh,32h,3fh,17h,3fh,34h
	.db 28h,18h,21h,18h,37h,18h,40h,18h,36h,26h,29h,26h
	.db 0,0,0,0,0,0,0,0,0,0,0,0
level8:
	.db 3,8
	.db 0bh,0dh,0bh,32h,53h,32h,53h,0fh,17h,0eh,54h,0eh
	.db 03h,20h,0ah,20h,5ch,20h,55h,20h,48h,32h,0dh,32h
	.db 17h,28h,17h,17h,47h,28h,47h,17h,21h,28h,46h,28h
	.db 19h,18h,3eh,18h,31h,30h,31h,29h,2fh,0fh,2fh,16h
	.db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
level9:
	.db 5,6
	.db 28h,20h,03h,20h,29h,11h,29h,2eh,35h,11h,35h,2eh
	.db 5ch,20h,35h,20h,17h,09h,17h,18h,47h,09h,47h,18h
	.db 19h,0ah,46h,0ah,17h,36h,17h,27h,46h,36h,19h,36h
	.db 47h,27h,47h,36h,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0
level10:
	.db 7,8
	.db 15h,0dh,15h,34h,49h,34h,49h,0fh,26h,34h,17h,34h
	.db 39h,34h,48h,34h,1fh,17h,1fh,2ch,3fh,17h,3fh,2ah
	.db 26h,18h,1fh,18h,39h,18h,40h,18h,38h,22h,27h,22h
	.db 03h,22h,14h,22h,5ch,22h,4bh,22h,26h,0eh,15h,0eh
	.db 4ah,0eh,39h,0eh,26h,2ch,21h,2ch,39h,2ch,40h,2ch

.end
	